package src.DrawningObjects;

import src.Entities.EntityAirplaneWithRadar;
import java.awt.*;
public class ExtentionDrawningAirplane {
    private static String getName(Color col) {
        if (col.equals(Color.RED))
            return new String("RED");
        if (col.equals(Color.GREEN))
            return new String("GREEN");
        if (col.equals(Color.BLUE))
            return new String("BLUE");
        if (col.equals(Color.YELLOW))
            return new String("YELLOW");
        if (col.equals(Color.WHITE))
            return new String("WHITE");
        if (col.equals(Color.GRAY))
            return new String("GRAY");
        if (col.equals(Color.BLACK))
            return new String("BLACK");
        if (col.equals(Color.PINK))
            return new String("PINK");
        return null;
    }
    private static Color getColor(String col){
        if(col.equals("RED"))
            return Color.RED;
        if(col.equals("GREEN"))
            return Color.GREEN;
        if(col.equals("BLUE"))
            return Color.BLUE;
        if(col.equals("YELLOW"))
            return Color.YELLOW;
        if(col.equals("WHITE"))
            return Color.WHITE;
        if(col.equals("GRAY"))
            return Color.GRAY;
        if(col.equals("BLACK"))
            return Color.BLACK;
        if(col.equals("PINK"))
            return Color.PINK;
        return null;
    }
    public static DrawningAirplane CreateDrawningAirplane(String info, char separatorForObject, int width, int height){
        String[] strs = info.split(Character.toString(separatorForObject));
        if(strs.length == 5){
            DrawningAirplane toRet = new DrawningAirplane(
                    Integer.parseInt(strs[0]),
                    Integer.parseInt(strs[1]),
                    getColor(strs[2]),
                    width,
                    height);
            toRet.ChangeIlluminatorNumb(Integer.parseInt(strs[3]));
            toRet.ChangeIDraw(Integer.parseInt(strs[4]));
            return toRet;
        }
        if(strs.length == 8){
            DrawningAirplane toRet = new DrawningAirplaneWithRadar(
                    Integer.parseInt(strs[0]),
                    Integer.parseInt(strs[1]),
                    getColor(strs[2]),
                    getColor(strs[7]),
                    Boolean.parseBoolean(strs[5]),
                    Boolean.parseBoolean(strs[6]),
                    width,
                    height);
            toRet.ChangeIlluminatorNumb(Integer.parseInt(strs[3]));
            toRet.ChangeIDraw(Integer.parseInt(strs[4]));
            return toRet;
        }
        return null;
    }
    public static String GetDataForSave(DrawningAirplane drawningAirplane, char separatorForObject){
        var airplane = drawningAirplane.EntityAirplane;
        if(airplane == null)
            return null;
        String colName = getName(airplane.BodyColor);
        var str = String.format("%d%c%d%c%s%c%d%c%d",
                airplane.Speed(),
                separatorForObject, (int)airplane.Weight(),
                separatorForObject, getName(airplane.BodyColor),
                separatorForObject, drawningAirplane._illuminatorsNumb,
                separatorForObject, drawningAirplane.GetIDrawType());
        if(!(airplane instanceof EntityAirplaneWithRadar)){
            return str;
        }
        var nstr = String.format("%s%c%b%c%b%c%s", str, separatorForObject,
                ((EntityAirplaneWithRadar) airplane).Radar(), separatorForObject,
                ((EntityAirplaneWithRadar) airplane).DopBak(), separatorForObject,
                getName(((EntityAirplaneWithRadar) airplane).AdditionalColor), separatorForObject);
        return nstr;
    }
}
